From 972b57195a3cfe2f2b4891cc71cee9e41c7dd886 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Sat, 19 Mar 2016 13:28:37 +0100
Subject: [PATCH] WIP ACPICA 20160318

---
 sys/conf/files                                     |   1 +
 sys/contrib/dev/acpica/changes.txt                 |  80 ++-
 .../dev/acpica/generate/unix/Makefile.common       |   4 +
 .../dev/acpica/generate/unix/Makefile.config       |  12 +
 .../dev/acpica/generate/unix/acpidump/Makefile     |   4 +
 .../dev/acpica/generate/unix/acpiexamples/Makefile |   1 +
 .../dev/acpica/generate/unix/acpiexec/Makefile     |   5 +
 sys/contrib/dev/acpica/generate/unix/iasl/Makefile |   2 +
 sys/contrib/dev/acpica/source/common/adwalk.c      |  82 ++-
 sys/contrib/dev/acpica/source/common/dmextern.c    | 174 ++---
 sys/contrib/dev/acpica/source/common/dmtable.c     |   6 +
 sys/contrib/dev/acpica/source/common/dmtables.c    |  39 +-
 sys/contrib/dev/acpica/source/common/dmtbdump.c    |  12 +-
 sys/contrib/dev/acpica/source/common/dmtbinfo.c    |  46 +-
 .../dev/acpica/source/compiler/aslcodegen.c        |   6 +
 .../dev/acpica/source/compiler/aslcompile.c        |  13 +-
 .../dev/acpica/source/compiler/aslcompiler.h       |   8 +
 .../dev/acpica/source/compiler/aslexternal.c       |  61 +-
 sys/contrib/dev/acpica/source/compiler/aslglobal.h |   1 +
 sys/contrib/dev/acpica/source/compiler/asllength.c |   8 +
 sys/contrib/dev/acpica/source/compiler/aslload.c   |  19 +
 .../dev/acpica/source/compiler/aslmessages.c       |   4 +-
 .../dev/acpica/source/compiler/aslopcodes.c        | 707 +-------------------
 sys/contrib/dev/acpica/source/compiler/aslopt.c    |  44 +-
 .../dev/acpica/source/compiler/asloptions.c        |   7 +
 sys/contrib/dev/acpica/source/compiler/aslpld.c    | 729 +++++++++++++++++++++
 .../dev/acpica/source/compiler/aslrestype2e.c      |   2 +-
 sys/contrib/dev/acpica/source/compiler/aslstubs.c  |   7 +
 .../dev/acpica/source/compiler/asltransform.c      |   6 +-
 sys/contrib/dev/acpica/source/compiler/aslutils.c  |   4 +-
 sys/contrib/dev/acpica/source/compiler/aslwalks.c  |   7 +-
 .../dev/acpica/source/compiler/aslxrefout.c        |  36 +-
 sys/contrib/dev/acpica/source/compiler/dtparser.y  |   6 +-
 sys/contrib/dev/acpica/source/compiler/dttable1.c  |  17 +-
 sys/contrib/dev/acpica/source/compiler/dttable2.c  |   4 +-
 .../dev/acpica/source/compiler/dttemplate.h        |  15 +-
 sys/contrib/dev/acpica/source/compiler/prparser.y  |   4 +-
 sys/contrib/dev/acpica/source/compiler/prscan.c    |  11 +
 .../acpica/source/components/debugger/dbconvert.c  |   3 +-
 .../acpica/source/components/debugger/dbinput.c    |  11 +-
 .../acpica/source/components/debugger/dbutils.c    |   8 +-
 .../source/components/disassembler/dmbuffer.c      |  84 +--
 .../source/components/disassembler/dmopcode.c      |   4 +-
 .../source/components/disassembler/dmresrc.c       |   8 +-
 .../source/components/disassembler/dmresrcl.c      |   6 +-
 .../source/components/disassembler/dmutils.c       |   2 +-
 .../dev/acpica/source/components/events/evregion.c |  82 +--
 .../dev/acpica/source/components/events/evrgnini.c |   1 -
 .../acpica/source/components/executer/exconcat.c   | 460 +++++++++++++
 .../acpica/source/components/executer/exconfig.c   |   5 +-
 .../acpica/source/components/executer/exconvrt.c   |   3 +-
 .../dev/acpica/source/components/executer/exdump.c |  23 +-
 .../dev/acpica/source/components/executer/exmisc.c | 302 ---------
 .../acpica/source/components/executer/exsystem.c   |   2 +-
 .../acpica/source/components/executer/exutils.c    |  12 +-
 .../dev/acpica/source/components/hardware/hwregs.c | 200 +++++-
 .../acpica/source/components/hardware/hwxface.c    |   3 +-
 .../acpica/source/components/namespace/nsaccess.c  |   2 +-
 .../acpica/source/components/namespace/nsconvert.c |   2 +-
 .../acpica/source/components/namespace/nsdump.c    |   9 +-
 .../acpica/source/components/namespace/nsinit.c    |  74 ++-
 .../acpica/source/components/namespace/nsload.c    |   2 +-
 .../acpica/source/components/namespace/nsprepkg.c  |  48 +-
 .../dev/acpica/source/components/parser/psopinfo.c |   2 +-
 .../acpica/source/components/resources/rsdump.c    |  44 +-
 .../acpica/source/components/resources/rsutils.c   |   2 +-
 .../dev/acpica/source/components/tables/tbfadt.c   |  25 +-
 .../dev/acpica/source/components/tables/tbxfload.c |  27 +-
 .../acpica/source/components/utilities/utdebug.c   |  40 +-
 .../acpica/source/components/utilities/uteval.c    |   4 +-
 .../acpica/source/components/utilities/utglobal.c  |  55 ++
 .../acpica/source/components/utilities/utmisc.c    |   2 +-
 .../acpica/source/components/utilities/utnonansi.c |  61 +-
 .../acpica/source/components/utilities/utprint.c   |   6 -
 .../acpica/source/components/utilities/uttrack.c   |   2 +-
 .../acpica/source/components/utilities/utxfinit.c  |  47 +-
 sys/contrib/dev/acpica/source/include/acdebug.h    |   4 +-
 sys/contrib/dev/acpica/source/include/acdisasm.h   |  11 +-
 sys/contrib/dev/acpica/source/include/acevents.h   |   4 -
 sys/contrib/dev/acpica/source/include/acglobal.h   |  10 +
 sys/contrib/dev/acpica/source/include/acinterp.h   |   2 +-
 sys/contrib/dev/acpica/source/include/aclocal.h    |   1 +
 sys/contrib/dev/acpica/source/include/acmacros.h   |   4 +
 sys/contrib/dev/acpica/source/include/acnamesp.h   |   4 +-
 sys/contrib/dev/acpica/source/include/acoutput.h   |   2 +-
 sys/contrib/dev/acpica/source/include/acparser.h   |   2 +-
 sys/contrib/dev/acpica/source/include/acpixf.h     |   2 +-
 sys/contrib/dev/acpica/source/include/acresrc.h    |   4 +-
 sys/contrib/dev/acpica/source/include/acstruct.h   |   2 +-
 sys/contrib/dev/acpica/source/include/actbl.h      |   2 +
 sys/contrib/dev/acpica/source/include/actbl1.h     |  49 +-
 sys/contrib/dev/acpica/source/include/actbl2.h     |  42 +-
 sys/contrib/dev/acpica/source/include/actbl3.h     |  52 +-
 sys/contrib/dev/acpica/source/include/actypes.h    |   4 +-
 sys/contrib/dev/acpica/source/include/acutils.h    |  18 +-
 .../dev/acpica/source/include/platform/acenv.h     |  44 +-
 .../dev/acpica/source/include/platform/acqnx.h     |  74 +++
 .../source/os_specific/service_layers/osbsdtbl.c   |   4 +
 .../source/os_specific/service_layers/osunixmap.c  |   2 +-
 .../dev/acpica/source/tools/acpidump/apdump.c      |   3 +-
 .../dev/acpica/source/tools/acpidump/apmain.c      |   3 +-
 .../dev/acpica/source/tools/acpiexec/aeinitfile.c  |   3 +-
 .../dev/acpica/source/tools/acpisrc/asfile.c       |   4 +-
 .../dev/acpica/source/tools/acpisrc/astable.c      |   4 +-
 .../acpica/source/tools/acpixtract/acpixtract.c    | 102 ++-
 .../acpica/source/tools/acpixtract/acpixtract.h    |   4 +
 .../dev/acpica/source/tools/acpixtract/axutils.c   |  75 +++
 sys/dev/acpica/Makefile                            |   3 +-
 usr.sbin/acpi/acpiexec/Makefile                    |   1 +
 usr.sbin/acpi/iasl/Makefile                        |   2 +
 110 files changed, 2663 insertions(+), 1751 deletions(-)
 create mode 100644 sys/contrib/dev/acpica/source/compiler/aslpld.c
 create mode 100644 sys/contrib/dev/acpica/source/components/executer/exconcat.c
 create mode 100644 sys/contrib/dev/acpica/source/include/platform/acqnx.h

diff --git a/sys/conf/files b/sys/conf/files
index ad4b4a0..4e8d4db 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -2317,6 +2317,7 @@ ${ACPICA_COMP_DIR}/events/evxface.c		optional acpi
 ${ACPICA_COMP_DIR}/events/evxfevnt.c		optional acpi
 ${ACPICA_COMP_DIR}/events/evxfgpe.c		optional acpi
 ${ACPICA_COMP_DIR}/events/evxfregn.c		optional acpi
+${ACPICA_COMP_DIR}/executer/exconcat.c		optional acpi
 ${ACPICA_COMP_DIR}/executer/exconfig.c		optional acpi
 ${ACPICA_COMP_DIR}/executer/exconvrt.c		optional acpi
 ${ACPICA_COMP_DIR}/executer/excreate.c		optional acpi
diff --git a/sys/contrib/dev/acpica/generate/unix/Makefile.common b/sys/contrib/dev/acpica/generate/unix/Makefile.common
index fe5e46b..cc6a101 100644
--- a/sys/contrib/dev/acpica/generate/unix/Makefile.common
+++ b/sys/contrib/dev/acpica/generate/unix/Makefile.common
@@ -9,8 +9,12 @@
 ifeq ($(HOST), _FreeBSD)
 HARDWARE_NAME := $(shell uname -p)
 else
+ifeq ($(HOST), _QNX)
+HARDWARE_NAME := x86pc
+else
 HARDWARE_NAME := $(shell uname -m)
 endif
+endif
 
 #
 # Main rule will only generate versions that are appropriate for the running
diff --git a/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile b/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile
index 313ad15..67e7e94 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile
@@ -64,6 +64,10 @@ ifeq ($(HOST), _NetBSD)
 HOST_FAMILY = BSD
 endif
 
+ifeq ($(HOST), _QNX)
+HOST_FAMILY = BSD
+endif
+
 ifeq ($(HOST_FAMILY), BSD)
 OBJECTS += \
 	$(OBJDIR)/osbsdtbl.o
diff --git a/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile b/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile
index 7d9daf3..f40c11b 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile
@@ -59,6 +59,7 @@ OBJECTS = \
 	$(OBJDIR)/evrgnini.o\
 	$(OBJDIR)/evxface.o\
 	$(OBJDIR)/evxfregn.o\
+	$(OBJDIR)/exconcat.o\
 	$(OBJDIR)/exconfig.o\
 	$(OBJDIR)/exconvrt.o\
 	$(OBJDIR)/excreate.o\
diff --git a/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile b/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
index 384089c..e473664 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
@@ -106,6 +106,7 @@ OBJECTS = \
 	$(OBJDIR)/evxfgpe.o\
 	$(OBJDIR)/evxfregn.o\
 	$(OBJDIR)/exconfig.o\
+	$(OBJDIR)/exconcat.o\
 	$(OBJDIR)/exconvrt.o\
 	$(OBJDIR)/excreate.o\
 	$(OBJDIR)/exdebug.o\
@@ -245,11 +246,15 @@ CFLAGS += \
     -DACPI_CHECKSUM_ABORT=TRUE
 endif
 
+ifneq ($(HOST),_QNX)
 LDFLAGS += -lpthread
+endif
 
 ifneq ($(HOST),_APPLE)
+ifneq ($(HOST),_QNX)
 LDFLAGS += -lrt
 endif
+endif
 
 #
 # Common Rules
diff --git a/sys/contrib/dev/acpica/generate/unix/iasl/Makefile b/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
index ed4ed2d..36c93d5 100644
--- a/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
@@ -96,6 +96,7 @@ OBJECTS = \
 	$(OBJDIR)/aslrestype2w.o\
 	$(OBJDIR)/aslstartup.o\
 	$(OBJDIR)/aslstubs.o\
+	$(OBJDIR)/aslpld.o\
 	$(OBJDIR)/asltransform.o\
 	$(OBJDIR)/asltree.o\
 	$(OBJDIR)/aslutils.o\
@@ -143,6 +144,7 @@ OBJECTS = \
 	$(OBJDIR)/dttable2.o\
 	$(OBJDIR)/dttemplate.o\
 	$(OBJDIR)/dtutils.o\
+	$(OBJDIR)/exconcat.o\
 	$(OBJDIR)/exconvrt.o\
 	$(OBJDIR)/excreate.o\
 	$(OBJDIR)/exdump.o\
diff --git a/sys/contrib/dev/acpica/source/common/adwalk.c b/sys/contrib/dev/acpica/source/common/adwalk.c
index 28255c6..714d837 100644
--- a/sys/contrib/dev/acpica/source/common/adwalk.c
+++ b/sys/contrib/dev/acpica/source/common/adwalk.c
@@ -327,6 +327,7 @@ AcpiDmConvertResourceIndexes (
         WalkState);
     if (ACPI_FAILURE (Status))
     {
+        ACPI_FREE (WalkState);
         return;
     }
 
@@ -442,7 +443,7 @@ AcpiDmDumpDescending (
  *
  * DESCRIPTION: Check namepath Ops for orphaned method invocations
  *
- * Note: Experimental.
+ * Note: Parts of this are experimental, under possible further development.
  *
  ******************************************************************************/
 
@@ -508,6 +509,7 @@ AcpiDmFindOrphanDescending (
                 ChildOp->Common.Value.String, ACPI_TYPE_METHOD, ArgCount, 0);
         }
         break;
+
 #endif
 
     case AML_STORE_OP:
@@ -532,7 +534,7 @@ AcpiDmFindOrphanDescending (
                 /* One Arg means this is just a Store(Name,Target) */
 
                 AcpiDmAddOpToExternalList (ChildOp,
-                    ChildOp->Common.Value.String, ACPI_TYPE_INTEGER, 0, 0);
+                    ChildOp->Common.Value.String, ACPI_TYPE_INTEGER, ArgCount, 0);
                 return (AE_OK);
             }
 
@@ -554,7 +556,7 @@ AcpiDmFindOrphanDescending (
             (ParentOp->Common.AmlOpcode != AML_INT_METHODCALL_OP) &&
             !Op->Common.Node)
         {
-            ArgCount = AcpiDmInspectPossibleArgs (0, 0, Op->Common.Next);
+            ArgCount = AcpiDmInspectPossibleArgs (0, 0, Op);
 
             /*
              * Check if namepath is a predicate for if/while or lone parameter to
@@ -788,6 +790,7 @@ AcpiDmXrefDescendingOp (
                 Op->Common.Next->Common.Next->Common.Value.Integer;
         }
 
+        Flags |= ACPI_EXT_RESOLVED_REFERENCE | ACPI_EXT_ORIGIN_FROM_OPCODE;
         AcpiDmAddOpToExternalList (Op, Path,
             (UINT8) ObjectType, ParamCount, Flags);
 
@@ -855,12 +858,12 @@ AcpiDmXrefDescendingOp (
     Status = AcpiNsLookup (WalkState->ScopeInfo, Path, ACPI_TYPE_ANY,
         ACPI_IMODE_EXECUTE, ACPI_NS_SEARCH_PARENT | ACPI_NS_DONT_OPEN_SCOPE,
         WalkState, &Node);
+
     if (ACPI_SUCCESS (Status) && (Node->Flags & ANOBJ_IS_EXTERNAL))
     {
         /* Node was created by an External() statement */
 
         Status = AE_NOT_FOUND;
-        Flags = ACPI_EXT_RESOLVED_REFERENCE;
     }
 
     if (ACPI_FAILURE (Status))
@@ -880,12 +883,12 @@ AcpiDmXrefDescendingOp (
                 if (Node)
                 {
                     AcpiDmAddNodeToExternalList (Node,
-                        (UINT8) ObjectType, 0, Flags);
+                        (UINT8) ObjectType, 7, Flags);
                 }
                 else
                 {
                     AcpiDmAddOpToExternalList (Op, Path,
-                        (UINT8) ObjectType, 0, Flags);
+                        (UINT8) ObjectType, 7, Flags);
                 }
             }
         }
@@ -1067,40 +1070,69 @@ AcpiDmInspectPossibleArgs (
 {
     const ACPI_OPCODE_INFO  *OpInfo;
     UINT32                  i;
-    UINT32                  Last = 0;
-    UINT32                  Lookahead;
+    UINT32                  ArgumentCount = 0;
+    ACPI_PARSE_OBJECT       *NextOp;
+    ACPI_PARSE_OBJECT       *ExecuteOp;
 
 
-    Lookahead = (ACPI_METHOD_NUM_ARGS + TargetCount) - CurrentOpArgCount;
+    if (!Op)
+    {
+        return (0);
+    }
 
     /* Lookahead for the maximum number of possible arguments */
 
-    for (i = 0; i < Lookahead; i++)
+    NextOp = Op->Common.Next;
+
+    for (i = 0; (i < ACPI_METHOD_NUM_ARGS) && NextOp; i++)
     {
-        if (!Op)
-        {
-            break;
-        }
+        OpInfo = AcpiPsGetOpcodeInfo (NextOp->Common.AmlOpcode);
 
-        OpInfo = AcpiPsGetOpcodeInfo (Op->Common.AmlOpcode);
+        /* Any one of these operators is "very probably" not a method arg */
 
-        /*
-         * Any one of these operators is "very probably" not a method arg
-         */
-        if ((Op->Common.AmlOpcode == AML_STORE_OP) ||
-            (Op->Common.AmlOpcode == AML_NOTIFY_OP))
+        if ((NextOp->Common.AmlOpcode == AML_STORE_OP) ||
+            (NextOp->Common.AmlOpcode == AML_NOTIFY_OP) ||
+            (OpInfo->Class == AML_CLASS_CONTROL) ||
+            (OpInfo->Class == AML_CLASS_CREATE) ||
+            (OpInfo->Class == AML_CLASS_NAMED_OBJECT))
         {
             break;
         }
 
-        if ((OpInfo->Class != AML_CLASS_EXECUTE) &&
-            (OpInfo->Class != AML_CLASS_CONTROL))
+        if (OpInfo->Class == AML_CLASS_EXECUTE)
         {
-            Last = i+1;
+            /* Probable that this is method arg if there is no target */
+
+            ExecuteOp = NextOp->Common.Value.Arg;
+            while (ExecuteOp)
+            {
+                if ((ExecuteOp->Common.AmlOpcode == AML_INT_NAMEPATH_OP) &&
+                    (ExecuteOp->Common.Value.Arg == NULL))
+                {
+                    /* No target, could be a method arg */
+
+                    break;
+                }
+
+                if (NextOp->Common.AmlOpcode == AML_REF_OF_OP)
+                {
+                    break;
+                }
+
+                ExecuteOp = ExecuteOp->Common.Next;
+            }
+
+            if (!ExecuteOp)
+            {
+                /* Has a target, not method arg */
+
+                return (ArgumentCount);
+            }
         }
 
-        Op = Op->Common.Next;
+        ArgumentCount++;
+        NextOp = NextOp->Common.Next;
     }
 
-    return (Last);
+    return (ArgumentCount);
 }
diff --git a/sys/contrib/dev/acpica/source/common/dmextern.c b/sys/contrib/dev/acpica/source/common/dmextern.c
index bb44b88..924c42f 100644
--- a/sys/contrib/dev/acpica/source/common/dmextern.c
+++ b/sys/contrib/dev/acpica/source/common/dmextern.c
@@ -754,46 +754,6 @@ AcpiDmAddPathToExternalList (
 
 /*******************************************************************************
  *
- * FUNCTION:    AcpiDmEternalIsMatch
- *
- * PARAMETERS:  NamePath            - Path to match to External Name
- *              ExternalPath        - External NamePath to be matched
- *
- * RETURN:      BOOLEAN
- *
- * DESCRIPTION: Returns TRUE if NamePath matches the last NamePath-length
- *              characters of ExternalPath.
- *
- *              External (_SB_.DEV0.ABCD) will match:
- *                  _SB_.DEV0.ABCD
- *                  DEV0.ABCD
- *                  ABCD
- *
- ******************************************************************************/
-
-static BOOLEAN
-AcpiDmExternalIsMatch (
-    const char *            NamePath,
-    const char *            ListNamePath)
-{
-    BOOLEAN                 Match = FALSE;
-
-
-    if (strlen (ListNamePath) >= strlen (NamePath))
-    {
-        if (!strcmp (ListNamePath +
-            (strlen (ListNamePath) - strlen (NamePath)), NamePath))
-        {
-            return (TRUE);
-        }
-    }
-
-    return (Match);
-}
-
-
-/*******************************************************************************
- *
  * FUNCTION:    AcpiDmCreateNewExternal
  *
  * PARAMETERS:  ExternalPath        - External path to the object
@@ -850,26 +810,29 @@ AcpiDmCreateNewExternal (
     {
         /* Check for duplicates */
 
-        if (AcpiDmExternalIsMatch (ExternalPath, NextExternal->Path))
+        if (!strcmp (ExternalPath, NextExternal->Path))
         {
-            /* Duplicate method, check that the Value (ArgCount) is the same */
-
-            if ((NextExternal->Type == ACPI_TYPE_METHOD) &&
-                (NextExternal->Flags & ANOBJ_IS_EXTERNAL) &&
-                (NextExternal->Value != Value) &&
-                (Value > 0))
+            /*
+             * If this external came from an External() opcode, we are
+             * finished with this one. (No need to check any further).
+             */
+            if (NextExternal->Flags & ACPI_EXT_ORIGIN_FROM_OPCODE)
             {
-                ACPI_ERROR ((AE_INFO,
-                    "External method arg count mismatch %s: "
-                    "Current %u, attempted %u",
-                    NextExternal->Path, NextExternal->Value, Value));
+                return_ACPI_STATUS (AE_ALREADY_EXISTS);
             }
 
             /* Allow upgrade of type from ANY */
 
-            else if (NextExternal->Type == ACPI_TYPE_ANY)
+            else if ((NextExternal->Type == ACPI_TYPE_ANY) &&
+                (Type != ACPI_TYPE_ANY))
             {
                 NextExternal->Type = Type;
+            }
+
+            /* Update the argument count as necessary */
+
+            if (Value < NextExternal->Value)
+            {
                 NextExternal->Value = Value;
             }
 
@@ -1125,90 +1088,63 @@ AcpiDmEmitExternals (
 
     AcpiDmUnresolvedWarning (1);
 
-    /* Emit any unresolved method externals in a single text block */
-
-    NextExternal = AcpiGbl_ExternalList;
-    while (NextExternal)
-    {
-        if ((NextExternal->Type == ACPI_TYPE_METHOD) &&
-            (!(NextExternal->Flags & ACPI_EXT_RESOLVED_REFERENCE)))
-        {
-            AcpiOsPrintf ("    External (%s%s",
-                NextExternal->Path,
-                AcpiDmGetObjectTypeName (NextExternal->Type));
-
-            AcpiOsPrintf (")    // Warning: Unresolved method, "
-                "guessing %u arguments\n",
-                NextExternal->Value);
-
-            NextExternal->Flags |= ACPI_EXT_EXTERNAL_EMITTED;
-        }
-
-        NextExternal = NextExternal->Next;
-    }
-
-    AcpiOsPrintf ("\n");
-
-
-    /* Emit externals that were imported from a file */
-
     if (Gbl_ExternalRefFilename)
     {
         AcpiOsPrintf (
-            "    /*\n     * External declarations that were imported from\n"
-            "     * the reference file [%s]\n     */\n",
+            "    /*\n     * External declarations were imported from\n"
+            "     * a reference file -- %s\n     */\n\n",
             Gbl_ExternalRefFilename);
-
-        NextExternal = AcpiGbl_ExternalList;
-        while (NextExternal)
-        {
-            if (!(NextExternal->Flags & ACPI_EXT_EXTERNAL_EMITTED) &&
-                (NextExternal->Flags & ACPI_EXT_ORIGIN_FROM_FILE))
-            {
-                AcpiOsPrintf ("    External (%s%s",
-                    NextExternal->Path,
-                    AcpiDmGetObjectTypeName (NextExternal->Type));
-
-                if (NextExternal->Type == ACPI_TYPE_METHOD)
-                {
-                    AcpiOsPrintf (")    // %u Arguments\n",
-                        NextExternal->Value);
-                }
-                else
-                {
-                    AcpiOsPrintf (")\n");
-                }
-                NextExternal->Flags |= ACPI_EXT_EXTERNAL_EMITTED;
-            }
-
-            NextExternal = NextExternal->Next;
-        }
-
-        AcpiOsPrintf ("\n");
     }
 
     /*
-     * Walk the list of externals found during the AML parsing
+     * Walk and emit the list of externals found during the AML parsing
      */
     while (AcpiGbl_ExternalList)
     {
+        AcpiGbl_ExternalList = AcpiGbl_ExternalList;
         if (!(AcpiGbl_ExternalList->Flags & ACPI_EXT_EXTERNAL_EMITTED))
         {
-            AcpiOsPrintf ("    External (%s%s",
+            AcpiOsPrintf ("    External (%s%s)",
                 AcpiGbl_ExternalList->Path,
                 AcpiDmGetObjectTypeName (AcpiGbl_ExternalList->Type));
 
-            /* For methods, add a comment with the number of arguments */
+            /* Check for "unresolved" method reference */
 
-            if (AcpiGbl_ExternalList->Type == ACPI_TYPE_METHOD)
+            if ((AcpiGbl_ExternalList->Type == ACPI_TYPE_METHOD) &&
+                (!(AcpiGbl_ExternalList->Flags & ACPI_EXT_RESOLVED_REFERENCE)))
             {
-                AcpiOsPrintf (")    // %u Arguments\n",
+                AcpiOsPrintf ("    // Warning: Unknown method, "
+                    "guessing %u arguments",
                     AcpiGbl_ExternalList->Value);
             }
+
+            /* Check for external from a external references file */
+
+            else if (AcpiGbl_ExternalList->Flags & ACPI_EXT_ORIGIN_FROM_FILE)
+            {
+                if (AcpiGbl_ExternalList->Type == ACPI_TYPE_METHOD)
+                {
+                    AcpiOsPrintf ("    // %u Arguments",
+                        AcpiGbl_ExternalList->Value);
+                }
+
+                AcpiOsPrintf ("    // From external reference file");
+            }
+
+            /* This is the normal external case */
+
             else
             {
-                AcpiOsPrintf (")\n");
+                /* For methods, add a comment with the number of arguments */
+
+                if (AcpiGbl_ExternalList->Type == ACPI_TYPE_METHOD)
+                {
+                    AcpiOsPrintf ("    // %u Arguments",
+                        AcpiGbl_ExternalList->Value);
+                }
             }
+
+            AcpiOsPrintf ("\n");
         }
 
         /* Free this external info block and move on to next external */
@@ -1341,15 +1277,17 @@ AcpiDmUnresolvedWarning (
     Format = Type ? Pad : NoPad;
 
     sprintf (ExternalWarningPart1,
-        "%s iASL Warning: There were %u external control methods found during\n"
+        "%s iASL Warning: There %s %u external control method%s found during\n"
         "%s disassembly, but only %u %s resolved (%u unresolved). Additional\n"
         "%s ACPI tables may be required to properly disassemble the code. This\n"
         "%s resulting disassembler output file may not compile because the\n"
         "%s disassembler did not know how many arguments to assign to the\n"
         "%s unresolved methods. Note: SSDTs can be dynamically loaded at\n"
         "%s runtime and may or may not be available via the host OS.\n",
-        Format, AcpiGbl_NumExternalMethods, Format, AcpiGbl_ResolvedExternalMethods,
-        (AcpiGbl_ResolvedExternalMethods > 1 ? "were" : "was"),
+        Format, (AcpiGbl_NumExternalMethods != 1 ? "were" : "was"),
+        AcpiGbl_NumExternalMethods, (AcpiGbl_NumExternalMethods != 1 ? "s" : ""),
+        Format, AcpiGbl_ResolvedExternalMethods,
+        (AcpiGbl_ResolvedExternalMethods != 1 ? "were" : "was"),
         (AcpiGbl_NumExternalMethods - AcpiGbl_ResolvedExternalMethods),
         Format, Format, Format, Format, Format);
 
@@ -1391,7 +1329,7 @@ AcpiDmUnresolvedWarning (
         {
             /* The -e option was specified, but there are still some unresolved externals */
 
-            AcpiOsPrintf ("    /*\n%s     *\n     *\n     */\n",
+            AcpiOsPrintf ("    /*\n%s     *\n%s     *\n%s     */\n",
                ExternalWarningPart1, ExternalWarningPart3, ExternalWarningPart4);
         }
     }
diff --git a/sys/contrib/dev/acpica/source/common/dmtable.c b/sys/contrib/dev/acpica/source/common/dmtable.c
index 89f6db0..14f0861 100644
--- a/sys/contrib/dev/acpica/source/common/dmtable.c
+++ b/sys/contrib/dev/acpica/source/common/dmtable.c
@@ -118,6 +118,7 @@ static const char           *AcpiDmEinjActions[] =
     "Check Busy Status",
     "Get Command Status",
     "Set Error Type With Address",
+    "Get Execute Timings",
     "Unknown Action"
 };
 
@@ -150,6 +151,7 @@ static const char           *AcpiDmErstActions[] =
     "Get Error Address Range",
     "Get Error Address Length",
     "Get Error Attributes",
+    "Execute Timings",
     "Unknown Action"
 };
 
@@ -209,6 +211,10 @@ static const char           *AcpiDmHestNotifySubnames[] =
     "NMI",
     "CMCI",                         /* ACPI 5.0 */
     "MCE",                          /* ACPI 5.0 */
+    "GPIO",                         /* ACPI 6.0 */
+    "SEA",                          /* ACPI 6.1 */
+    "SEI",                          /* ACPI 6.1 */
+    "GSIV",                         /* ACPI 6.1 */
     "Unknown Notify Type"           /* Reserved */
 };
 
diff --git a/sys/contrib/dev/acpica/source/common/dmtables.c b/sys/contrib/dev/acpica/source/common/dmtables.c
index 5758b9d..85abfe7 100644
--- a/sys/contrib/dev/acpica/source/common/dmtables.c
+++ b/sys/contrib/dev/acpica/source/common/dmtables.c
@@ -141,7 +141,6 @@ AdCreateTableHeader (
     char                    *Filename,
     ACPI_TABLE_HEADER       *Table)
 {
-    char                    *NewFilename;
     UINT8                   Checksum;
 
 
@@ -184,11 +183,10 @@ AdCreateTableHeader (
 
         break;
     }
-    AcpiOsPrintf ("\n");
 
     /* Print and validate the table checksum */
 
-    AcpiOsPrintf (" *     Checksum         0x%2.2X",        Table->Checksum);
+    AcpiOsPrintf ("\n *     Checksum         0x%2.2X",        Table->Checksum);
 
     Checksum = AcpiTbChecksum (ACPI_CAST_PTR (UINT8, Table), Table->Length);
     if (Checksum)
@@ -205,33 +203,16 @@ AdCreateTableHeader (
     AcpiOsPrintf (" *     Compiler Version 0x%8.8X (%u)\n", Table->AslCompilerRevision, Table->AslCompilerRevision);
     AcpiOsPrintf (" */\n");
 
-    /* Create AML output filename based on input filename */
-
-    if (Filename)
-    {
-        NewFilename = FlGenerateFilename (Filename, "aml");
-    }
-    else
-    {
-        NewFilename = UtStringCacheCalloc (9);
-        if (NewFilename)
-        {
-            strncat (NewFilename, Table->Signature, 4);
-            strcat (NewFilename, ".aml");
-        }
-    }
-
-    if (!NewFilename)
-    {
-        AcpiOsPrintf (" **** Could not generate AML output filename\n");
-        return;
-    }
-
-    /* Open the ASL definition block */
-
+    /*
+     * Open the ASL definition block.
+     *
+     * Note: the AMLFilename string is left zero-length in order to just let
+     * the compiler create it when the disassembled file is compiled. This
+     * makes it easier to rename the disassembled ASL file if needed.
+     */
     AcpiOsPrintf (
-        "DefinitionBlock (\"%s\", \"%4.4s\", %hu, \"%.6s\", \"%.8s\", 0x%8.8X)\n",
-        NewFilename, Table->Signature, Table->Revision,
+        "DefinitionBlock (\"\", \"%4.4s\", %hu, \"%.6s\", \"%.8s\", 0x%8.8X)\n",
+        Table->Signature, Table->Revision,
         Table->OemId, Table->OemTableId, Table->OemRevision);
 }
 
diff --git a/sys/contrib/dev/acpica/source/common/dmtbdump.c b/sys/contrib/dev/acpica/source/common/dmtbdump.c
index c6e0c4e..efc383d 100644
--- a/sys/contrib/dev/acpica/source/common/dmtbdump.c
+++ b/sys/contrib/dev/acpica/source/common/dmtbdump.c
@@ -1773,6 +1773,12 @@ AcpiDmDumpIort (
             IortSmmu = ACPI_ADD_PTR (ACPI_IORT_SMMU, IortNode, NodeOffset);
             break;
 
+        case ACPI_IORT_NODE_SMMU_V3:
+
+            InfoTable = AcpiDmTableInfoIort4;
+            Length = IortNode->Length - NodeOffset;
+            break;
+
         default:
 
             AcpiOsPrintf ("\n**** Unknown IORT node type 0x%X\n",
@@ -3139,7 +3145,7 @@ AcpiDmDumpS3pt (
 {
     ACPI_STATUS             Status;
     UINT32                  Offset = sizeof (ACPI_TABLE_S3PT);
-    ACPI_S3PT_HEADER        *SubTable;
+    ACPI_FPDT_HEADER        *SubTable;
     ACPI_DMTABLE_INFO       *InfoTable;
     ACPI_TABLE_S3PT         *S3ptTable = ACPI_CAST_PTR (ACPI_TABLE_S3PT, Tables);
 
@@ -3152,7 +3158,7 @@ AcpiDmDumpS3pt (
         return 0;
     }
 
-    SubTable = ACPI_ADD_PTR (ACPI_S3PT_HEADER, S3ptTable, Offset);
+    SubTable = ACPI_ADD_PTR (ACPI_FPDT_HEADER, S3ptTable, Offset);
     while (Offset < S3ptTable->Length)
     {
         /* Common subtable header */
@@ -3204,7 +3210,7 @@ NextSubTable:
         /* Point to next subtable */
 
         Offset += SubTable->Length;
-        SubTable = ACPI_ADD_PTR (ACPI_S3PT_HEADER, SubTable, SubTable->Length);
+        SubTable = ACPI_ADD_PTR (ACPI_FPDT_HEADER, SubTable, SubTable->Length);
     }
 
     return (S3ptTable->Length);
